<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>jQuery Form Submit</title>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
<script src="https://use.fontawesome.com/releases/v5.15.1/js/all.js" data-auto-replace-svg="nest"></script>
<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
<!--<script src="jquery-1.12.4.min.js"></script>-->
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>

<script>
var resultFromServer = null;
var server = "https://wedat.it";
var mode = "";
var ACTION_CREATE = server+"/myClaimDMS/create.php?env=TEST"+mode;
var ACTION_READ   = server+"/myClaimDMS/read.php?env=TEST"+mode;
var ACTION_UPDATE = server+"/myClaimDMS/update.php?env=TEST"+mode;
var ACTION_DELETE = server+"/myClaimDMS/delete.php?env=TEST"+mode;
var FRAME_DIR = server+"/myClaimDMS/frontend/";

function changeOfflineMode()
{
    (mode=='')?mode="&mode=offline":mode='';
    ACTION_CREATE = server+"/myClaimDMS/create.php?env=TEST"+mode;
    ACTION_READ   = server+"/myClaimDMS/read.php?env=TEST"+mode;
    ACTION_UPDATE = server+"/myClaimDMS/update.php?env=TEST"+mode;
    ACTION_DELETE = server+"/myClaimDMS/delete.php?env=TEST"+mode;
}

function selectItem(i)
{
    var myCollection = JSON.parse(resultFromServer);

    $("#collName_GET").val(myCollection.type);
    $("#subjId_GET").val(i);

    $('#insertForm input').val('').change();
    $('#insertForm textarea').val('').change();
    var myObj = myCollection.subjects[i];
    var kind = $("#REQ_COLLECTIONNAME_READ").val();

    jQuery.each(myObj, function(attrName, attrValue) {
        var attrId = "#"+kind+"_"+attrName;
        $(attrId).val(attrValue);
    });
}

function generateListOfSubjects(jsonObjFromServer)
{
    $("#readResultList").html('');
    var subjects = jsonObjFromServer.subjects;

    var listItem = '';

    jQuery.each(subjects, function(i, val) {
        listItem += '<li><a id="'+i+'" href="#" class="list-group-item list-group-item-action" ' +
            'onClick="selectItem('+i+');">'+getListItemContent(jsonObjFromServer.type,val)+'</a></li>';
    });
    $("#readResultList").append(listItem);

    myTrigger();
}

function getListItemContent(type, val) {
    switch (type) {
        case 'notesBlock':
            return val.name;
		case 'repairer':
            return val.name +'<p class="subAddress">'+val.zip+' '+val.city+' '+val.province+'-'+val.phone+"</p>";
		case 'legal':
            return val.name +'<p class="subAddress">'+val.zip+' '+val.city+' '+val.province+'-'+val.phone+"</p>";
		case 'authority':
            return val.name +'<p class="subAddress">'+val.zip+' '+val.city+' '+val.province+'-'+val.phone+"</p>";
		case 'insurance':
            return val.code+" "+val.name +'<p class="subAddress">'+val.zip+' '+val.city+' '+val.province+'-'+val.phone+"</p>";
        case 'insured':
            return val.name+' '+val.surname+'<p class="subAddress">'+val.zip+' '+val.city+' '+val.province+'-'+val.phone+"</p>";
		case 'owner':
            return val.name+' '+val.surname+'<p class="subAddress">'+val.zip+' '+val.city+' '+val.province+'-'+val.phone+"</p>";
		case 'co_owner':
            return val.name+' '+val.surname+'<p class="subAddress">'+val.zip+' '+val.city+' '+val.province+'-'+val.phone+"</p>";
		case 'opponent':
            return val.name+' '+val.surname+'<p class="subAddress">'+val.zip+' '+val.city+' '+val.province+'-'+val.phone+"</p>";
        default:
            return 'UNDEFINED';
    }
}

function myTrigger()
{
    parent.$('body').trigger('iFrameListLoaded');
    $("#changingOnResponse").click();
}

function editSubject() {
    var data = new Object();
    var kind = $("#REQ_COLLECTIONNAME_READ").val();

    var fieldName  = '';
    var fieldValue = '';

    $('#insertForm input.kind_'+kind+'').each(function(){
        fieldName  = $(this).attr('id');
        fieldName  = fieldName.replace(kind+'_', '');
        fieldValue = $(this).val();
        data[fieldName] = fieldValue;
    });
    $('#insertForm textarea.kind_'+kind+'').each(function(){
        fieldName  = $(this).attr('id');
        fieldName  = fieldName.replace(kind+'_', '');
        fieldValue = $(this).val();
        data[fieldName] = fieldValue;
    });
    waitStatus(true);
    $.ajax({
        url: ($("#subjId_GET").val()==0)?ACTION_CREATE:ACTION_UPDATE,
        type: "POST",
        data: {
            mast: $("#REQ_MASTERACCOUNT_READ").val(),
            cust: $("#REQ_CUSTOMERNUMBER_READ").val(),
            coll: kind,
            sbid: $("#subjId_GET").val(),
            subj: JSON.stringify(data)
        },
        success: function(result){
            waitStatus(false);
            $("#serverResponse").html(result);
            $("#readBtn").click();
        }
    });
}

function deleteSubject() {
    var data = new Object();

    $.ajax({
        url: ACTION_DELETE,
        type: "POST",
        data: {
            mast: $("#REQ_MASTERACCOUNT_READ").val(),
            cust: $("#REQ_CUSTOMERNUMBER_READ").val(),
            coll: $("#REQ_COLLECTIONNAME_READ").val(),
            sbid: $("#subjId_GET").val(),
            subj: JSON.stringify(data)
        },
        success: function(result){
            selectItem(0);
            $("#serverResponse").html(result);
            $("#readBtn").click();
        }
    });
}

/* implementare qui l'animazione da visualizzare durante il salvataggio */
function waitStatus(wait=true)
{
    return;
    if (wait == true) {
        $('a[href="#saveSubjectWait"]').show();
        $('a[href="#saveSubject"]').hide();
    } else {
        $('a[href="#saveSubjectWait"]').hide();
        $('a[href="#saveSubject"]').show();
    }
}

function loadFrame(kind)
{
    $.ajax({
        url: FRAME_DIR+kind+'.php',
        type: "GET",
        success: function (result) {
            $("#insertForm").html(result);
            myTrigger();
        }
    });
}

function loadSubject() {
    console.log(2);
    waitStatus(false);

    var kind = $("#REQ_COLLECTIONNAME_READ").val();
    loadFrame(kind);
    $("#REQ_COLLECTIONNAME_READ").val(kind);

    $.ajax({
        url: ACTION_READ,
        type: "POST",
        data: {
            mast: $("#REQ_MASTERACCOUNT_READ").val(),
            cust: $("#REQ_CUSTOMERNUMBER_READ").val(),
            coll: kind
        },
        success: function (result) {
            $("#readResult").html(result);
            console.log(result);
            resultFromServer = result;
            generateListOfSubjects(JSON.parse(result));
            console.log(4);
        }
    });
}



$(document).on('loadSubject', loadSubject());

$(document).ready(function(){


    //$('input[class^="kind"], label[class^="kind"]').hide();

    /*
    $("#readBtn").on('click', function() {
        var kind = $("#REQ_COLLECTIONNAME_READ").val();

        loadFrame(kind);
        $("#REQ_COLLECTIONNAME_READ").val(kind);

        $.ajax({
            url: ACTION_READ,
            type: "POST",
            data: {
                mast: $("#REQ_MASTERACCOUNT_READ").val(),
                cust: $("#REQ_CUSTOMERNUMBER_READ").val(),
                coll: kind
            },
            success: function (result) {
                $("#readResult").html(result);
                resultFromServer = result;
                generateListOfSubjects(JSON.parse(result));
            }
        });
    });
     */
});
function filterFunction() {
    var input, filter, ul, li, a, i;
    input = document.getElementById("searchInput");
    filter = input.value.toUpperCase();
    ul = document.getElementById("readResultList");
    li = ul.getElementsByTagName("li");
    for (i = 0; i < li.length; i++) {
        a = li[i].getElementsByTagName("a")[0];
        if (a.innerHTML.toUpperCase().indexOf(filter) > -1) {
            li[i].style.display = "";
        } else {
            li[i].style.display = "none";
        }
    }
}
</script>
<style>
body{
    background: #f8f8f8;
}
.btn-success{
background-color:#4ecb93;
border:0px;
}

.btn-danger{
background-color:#ee5362;
border:0px;
}
#serverResponse{
 display:none;
}
.subAddress {
    font-size: 11px;
    color: grey;
}
.form-control {
    background-color: #fff;
    color: #363636;
    font-size: 1rem;
    font-weight: 400;
    line-height: 1.5;
    justify-content: flex-start;
    line-height: 1.5;
    padding: calc(.375em - 1px) calc(.625em - 1px);
    border: 1px transparent;
	display:inline-block !important;
}
label {
    color: #86868b;
    text-transform: uppercase;
    font-size: 11px;
    margin: 0px;
    position: relative;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
    float: left;
}
.hiddenAbsolute{
visibility:hidden;
position:absolute;
}
#readResultList{
list-style-type: none;
height:500px;
overflow-y:auto;
}
#readResultList a{
padding-top: 0px;
padding-bottom: 0px;
}
.selectedA{
background-color: #ffbf00 !important;
color: black !important;
}
.subAddress{
border-bottom:0px;
}
.itemSelected {
    background: #007bff;
    color: white;
}
</style>
</head>
<body>
    <div class="container-fluid" style="display:none;">
        <div class="row">
            <input type="checkbox" id="offlinemode" name="offlinemode" onclick="changeOfflineMode()"/>
            <label for="offlinemode">Offline Mode</label><br>
        </div>
        <div class="row">
            <form method="post" action="#" id="readForm">
            <label for="REQ_CALLERPREFIX">Caller:</label>
            <input type="text" id="REQ_CALLERPREFIX" value="">
            <label for="REQ_MASTERACCOUNT_READ">Master account:</label>
            <input type="text" id="REQ_MASTERACCOUNT_READ" value="3132952">
            <label for="REQ_CUSTOMERNUMBER_READ">Customer Number:</label>
            <input type="text" id="REQ_CUSTOMERNUMBER_READ" value="3132952">
            <label for="REQ_COLLECTIONNAME_READ">Collection Name:</label>
            <input type="text" id="REQ_COLLECTIONNAME_READ" value="owner"/>

            <button type="button" id="readBtn" onclick="loadSubject()">READ</button>
            </form>
        </div>
        <div class="row">
            <table id="readTable"></table>
            <div id="readResult"></div>
        </div>
        <div class="row">
            <div id="serverResponse"></div>
        </div>
        <div style="display:none">
            <button id="changingOnResponse" type="text" value="0"/>
        </div>
    </div>
    <hr>
    <div class="container-fluid ">
        <div class="row w-100" style="
    position: fixed;
    z-index: 1;
    background-color: #f8f8f8;
    border-bottom: 1px solid #e9ecef;">
            <div style="width:100%">
                <h2 style="display:inline-block;margin-left:15px"><span id="variableTitle">Anagrafica</span><b id="variableSubject">Proprietario</b></h2>  <a href="#exitSubject" onclick="generateListOfSubjects('{}')"  class="btn btn-primary" data-toggle="modal" style="    display: inline-block;
    float: right;
    margin-right: 20px;
    font-size: 25px;
    color: black;
    background-color: transparent;
    border-color: transparent;"><i class="fas fa-arrow-right"></i> </a>
            </div>
            <div class="col-sm-6">
                <!--a href="#createSubject"  onclick=""  class="btn btn-info" data-toggle="modal"><i class="material-icons">&#9734;</i>  <span>Modifica</span></a>
                <a href="#createSubject"  onclick=""  class="btn btn-info" data-toggle="modal"><i class="material-icons">&#9734;</i>  <span>Seleziona</span></a-->
            </div>
        </div>
        <div class="row w-100 order-md-1 mb-4">
            <div class="col-sm-4" style="margin-top: 70px;">
                <form id="searchBar" class="form-inline">
                    <input id="searchInput" class="form-control" type="search" placeholder="Cerca per nome, città, pv, cap" aria-label="Cerca" onkeyup="filterFunction()" style="width:calc(100% - 20px);"><i class="fas fa-search" id="searchIcon" style="position:relative;left:4px;"></i>

                </form>
				 <a href="#createSubject"  onclick="selectItem(0)"  class="btn btn-primary" data-toggle="modal" style="width:100%;margin-top:6px;margin-bottom:4px;background-color:#4582EC"><i class="fas fa-plus"></i>  <span>Nuovo</span></a>
                <div id="readResultList"  class="list-group"></div>
            </div>
            <div class="col-sm-8" style="margin-top: 70px;">
                <!--<input type="hidden" id="REQ_CUSTOMERNUMBER">-->
                <!--<input type="hidden" id="REQ_COLLECTIONNAME">-->
                <input type="hidden" id="collName_GET"/>
                <input type="hidden" id="subjId_GET"/>
                <div id="insertForm" class="form-group">
                </div>
                <div>
            </div>
        </div>
        <div class="row w-100">
            <div class="col-sm-6">
                <span>&nbsp;</span>
            </div>
            <div style="position:fixed;bottom:0px;right:0px; width:100%;background-color:#e9ecef;text-align:center;padding-top:6px;padding-bottom:6px;">
                <span id="messageAnagrafica" style="display:none;">Voce non salvata</span>
				<a href="#saveSubject" onclick="editSubject();" class="btn btn-success" data-toggle="modal"><i class="fas fa-save"></i>  <span>Aggiungi ad Anagrafica</span></a>
                <span>&nbsp;</span>
                <a href="#deleteSubject" onclick="deleteSubject();" class="btn btn-danger" data-toggle="modal"><i class="fas fa-trash"></i>  <span>Rimuovi</span></a>
                <span>&nbsp;</span>
               </div>
        </div>
</body>
</html>